package dns

import (
	"net"
	"testing"

	csm "git.loafle.net/commons/service_matcher-go"
)

func TestDns(t *testing.T) {
	m := NewMatcher()

	conn, _ := net.Dial("udp", "192.168.1.254:53")

	defer conn.Close()

	for i := 0; i < m.PacketCount(); i++ {
		if m.IsSend(53) != true {
			t.Error("not port")
		}
		pack := m.Packet(i)
		conn.Write(pack.Buffer)
		bytes := make([]byte, 1024)
		n, _ := conn.Read(bytes)
		p := csm.NewPacket(bytes, n)

		if err := m.Match(nil, 0, p); err != nil {
			t.Error(err)
		}
	}

	t.Log(m.Meta())
}
