package elasticsearch

import (
	"net"
	"testing"

	csm "git.loafle.net/commons/service_matcher-go"
)

func TestES(t *testing.T) {
	m := NewMatcher()

	conn, err := net.Dial("tcp", "localhost:9200")
	if err != nil {
		t.Errorf("ERR %s", err)
	}

	defer conn.Close()

	for i := 0; i < m.PacketCount(); i++ {
		_, err := conn.Write(m.Packet(i).Buffer)
		if err != nil {
			t.Error(err)
		}
		bytes := make([]byte, 1024)
		n, _ := conn.Read(bytes)
		p := csm.NewPacket(bytes, n)

		if err := m.Match(nil, i, p); err != nil {
			t.Error(err)
		}
	}
	t.Log(m.Name())
	t.Log(m.Meta())
}
