package v2

import (
	"net"
	"testing"

	csm "git.loafle.net/commons/service_matcher-go"
)

func TestSNMPv2(t *testing.T) {

	m := NewMatcher()

	conn, err := net.Dial("udp", "192.168.1.99:161")
	if err != nil {
		t.Error(err)
		return
	}
	defer conn.Close()

	pack := m.Packet(0)
	conn.Write(pack.Buffer)

	bytes := make([]byte, 1024)
	n, _ := conn.Read(bytes)
	p := csm.NewPacket(bytes, n)

	if err := m.Match(nil, 0, p); err != nil {
		t.Error(err)
	}
	t.Log(m.Meta())
}
