package v3

import (
	"net"
	"testing"

	csm "git.loafle.net/commons/service_matcher-go"
)

func TestSNMP3(t *testing.T) {

	m := NewMatcher()

	conn, err := net.Dial("udp", "192.168.1.204:161")
	if err != nil {
		t.Error(err)
		return
	}
	defer conn.Close()

	for i := 0; i < m.PacketCount(); i++ {

		pack := m.Packet(i)
		conn.Write(pack.Buffer)
		bytes := make([]byte, 1024)
		n, _ := conn.Read(bytes)
		p := csm.NewPacket(bytes, n)

		if m.Match(nil, i, p) {
			t.Log("SNMP found")
			return
		}

		t.Error("SNMP not found")
	}

}
