package telnet

import (
	csm "git.loafle.net/commons/service_matcher-go"

	"net"
	"testing"
)

func TestTelnetMatcher_Match(t *testing.T) {

	m := NewMatcher()

	conn, err := net.Dial("tcp", "192.168.1.201:23")
	if err != nil {
		t.Error(err)
	}

	defer conn.Close()

	for i := 0; i < m.PacketCount(); i++ {
		_, err := conn.Write(m.Packet(i).Buffer)
		if err != nil {
			t.Error(err)
		}
		bytes := make([]byte, 1024)
		n, _ := conn.Read(bytes)
		p := csm.NewPacket(bytes, n)

		if err := m.Match(nil, i, p); err != nil {
			t.Error(err)
			return
		}
	}
	t.Log(m.Name())
	t.Log(m.Meta())

}
